var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
export function stringifyCSS(data, depth) {
    if (depth === void 0) { depth = 0; }
    var indent = ' '.repeat(4 * depth), _a = __read(Object.entries(data).reduce(function (_a, _b) {
        var _c = __read(_a, 2), simple = _c[0], nested = _c[1];
        var _d = __read(_b, 2), key = _d[0], value = _d[1];
        if (typeof value !== 'object')
            simple.push([key, value]);
        else
            nested.push([key, value]);
        return [simple, nested];
    }, [[], []]), 2), simple = _a[0], nested = _a[1];
    return simple[0]
        ? simple.map(function (_a) {
            var _b = __read(_a, 2), key = _b[0], value = _b[1];
            return "" + indent + key + ": " + value + ";\n";
        }).join('')
        : nested
            .map(function (_a) {
            var _b = __read(_a, 2), key = _b[0], value = _b[1];
            return "" + indent + key + " {\n" + stringifyCSS(value, depth + 1) + indent + "}\n";
        })
            .join('');
}
var spawn = document.createElement('template'), cache = {};
export function templateOf(tagName) {
    if (cache[tagName])
        return cache[tagName];
    spawn.innerHTML = "<" + tagName + " />";
    return (cache[tagName] = spawn.content.firstElementChild);
}
export function elementTypeOf(tagName) {
    var node = templateOf(tagName);
    return node instanceof HTMLElement && !(node instanceof HTMLUnknownElement)
        ? 'html'
        : 'xml';
}
// fetch from https://html.spec.whatwg.org/
export var ReadOnly_Properties = {
    HTMLLinkElement: ['sizes'],
    HTMLIFrameElement: ['sandbox'],
    HTMLObjectElement: ['form'],
    HTMLInputElement: ['form', 'list'],
    HTMLButtonElement: ['form'],
    HTMLSelectElement: ['form'],
    HTMLTextAreaElement: ['form'],
    HTMLOutputElement: ['form'],
    HTMLFieldSetElement: ['form']
};
//# sourceMappingURL=DOM.js.map