var meta = new WeakMap();
function defineMetadata(key, value, target) {
    var data = meta.get(target) || {};
    data[key] = value;
    meta.set(target, data);
}
function getMetadata(key, target) {
    var data = meta.get(target);
    if (data)
        return data[key];
}
export var Reflect = { defineMetadata: defineMetadata, getMetadata: getMetadata };
export function toHyphenCase(raw) {
    return raw.replace(/[A-Z]+/g, function (match) { return '-' + match.toLowerCase(); });
}
export function toCamelCase(raw) {
    return raw.replace(/-[a-z]/g, function (match) { return match[1].toUpperCase(); });
}
//# sourceMappingURL=data.js.map