export function delegate(selector, handler) {
    return function (event) {
        var node, path = event.composedPath();
        while ((node = path.shift()) && node !== event.currentTarget)
            if (node instanceof HTMLElement && node.matches(selector))
                return handler.call(this, event, node, event.detail);
    };
}
export var documentReady = new Promise(function (resolve) {
    document.addEventListener('DOMContentLoaded', resolve);
    self.addEventListener('load', resolve);
    setTimeout(function check() {
        document.readyState === 'complete' ? resolve() : setTimeout(check);
    });
});
//# sourceMappingURL=event.js.map